package com.unipi.talepis.iatriki2022_5;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@RestController
public class AppController {
    @Autowired
    private CovidCaseRepository covidCaseRepository;
    @GetMapping("/patientList")
    public Iterable<CovidCase> getCovidCases(){
        return covidCaseRepository.findAll();
    }
    @GetMapping("/find/{id}")
    public CovidCase findCaseById(@PathVariable Integer id){
        return covidCaseRepository.findCovidCaseById(id);
    }
    @PostMapping("/newCase")
    public String addCovidCase(@RequestBody Map<String,String> body){
        CovidCase covidCase = new CovidCase();
        covidCase.setId(Integer.parseInt(body.get("id")));
        covidCase.setPatientName(body.get("patientName"));
        covidCase.setDate(body.get("date"));
        covidCase.setExistingDisease(body.get("existingDisease"));
        covidCaseRepository.save(covidCase);
        return "Covid Case inserted successfully";
    }
    @PutMapping("/updateCase")
    public String updateCovidCase(@RequestBody Map<String,String> body){
        CovidCase covidCase = covidCaseRepository.findCovidCaseById(Integer.parseInt(body.get("id")));
        if (covidCase!=null){
            covidCase.setPatientName(body.get("patientName"));
            covidCase.setDate(body.get("date"));
            covidCase.setExistingDisease(body.get("existingDisease"));
            covidCaseRepository.save(covidCase);
        }
        return "Covid Case updated successfully";
    }
}
